Nebulae_FM_Grit_V1.1.csd 
for the Qu-Bit Electronix Nebulae Eurorack module
www.qubitelectronix.com

FM Grit was made for gritty FM synthesis via extreme C:M ratios and modulation index ranges.

January 7, 2015

Collin Russell
collinrussellmusic.com
collinrussell0912@gmail.com 

<CsoundSynthesizer>
<CsOptions>

-odac
--sched
-d
-+rtaudio=alsa
-Ma
-b512
-B1024
-m 0
 
</CsOptions>
<CsInstruments>

sr	     = 22050	
ksmps	     = 64
nchnls     = 1
0dbfs	     = 1

; Global Reverb
gaverb init 0

instr 1	
     
     ; These must be called once Csound is running
	ksystem system 1, "umount /dev/sda1 " 				; Unmounts flash drive
	ksystem system 1, "/home/scripts/fileLoadFeedback" 	; Tells arduino .csd loaded (This MUST be called)
	ksystem system 1, "/home/scripts/state_change pause" 
	ksystem system 1, "/home/scripts/state_change loop" 
	
	kutility ctrl7 1, 23, 0, 127

	; Verb Mix (Speed)
	kverbmix	ctrl14 1, 1, 2, 0, 0.35
	
	; Pitch
	kpitch 	ctrl14 1, 15, 16, -2, 3

	; Make pitch 1V/Octave
	kpitch 		pow 2, kpitch
	
	; Carrier Ratio (Mix)
	kcar 		ctrl7 1, 8, 1, 50
	
	; Modulator Ratio (Grain Size)
	kmod 		ctrl7 1, 4, 1, 50

	; Modulation Index (Grain Rate)
	kndx 		ctrl7 1, 5, 1, 100
	kndx       port  kndx, .01

	; Filter Cutoff (Loop Start)
	kcutoff 	ctrl7 1, 9, 40, 6000 

	; Resonance (Loop Size)
	kresonance	ctrl7 1, 11, 0, 0.8
	
		; Initialize Amplitde
	kamp = 0.95
	
	; Amplitude On/Off
	if (kutility == 1) then ; Amplitude is on

		kamp = 0

	elseif (kutility ==2) then ; Amplitude is off

		kamp = 0.95

	endif
	
  	; Load new files or .csd
  	if (kutility == 23) then
    	ksystem system 1, "echo 3 > /var/tmp/start_flag"
    	event "e", 0, 0, 0
	endif     

	; Go to next .csd
	if (kutility == 24) then
    	ksystem system 1, "echo 1 > /var/tmp/start_flag"
    	event "e", 0, 0, 0
	endif

	asig 	foscili kamp, kpitch, kcar, kmod, kndx, 1	; FM oscillator
	afilter	moogvcf2 asig, kcutoff, kresonance	; Moog-style ladder filter
	out (1-kverbmix)*afilter					; Mono output
	gaverb = gaverb + (afilter*kverbmix)			; Reverb send
endin


instr 2
	; Reverb Time (Glide)
	ktime ctrl14 1, 70, 71, 0, 0.7

	averb, averbR 	reverbsc gaverb, gaverb*0, ktime, 12000	; Reverb effect
	out averb										; Reverb out
	gaverb = 0										; Reverb cleared (Prevents clicks and pops at the end of reverb decay)
endin
	

</CsInstruments>
<CsScore>

;F#	LdTm	Size	GEN	Val
;~~~~~~~~~~~~~~~~~~~~~~~~~
f1 0 16384 10 1              ; Sine Wave


;Inst	     Strt	      Dur
;~~~~~~~~~~~~~~~~~~~~~~~~~~
i1 		0 		$INF
i2 		0 		$INF

</CsScore>
</CsoundSynthesizer>
<bsbPanel>
 <label>Widgets</label>
 <objectName/>
 <x>100</x>
 <y>100</y>
 <width>320</width>
 <height>240</height>
 <visible>true</visible>
 <uuid/>
 <bgcolor mode="nobackground">
  <r>255</r>
  <g>255</g>
  <b>255</b>
 </bgcolor>
</bsbPanel>
<bsbPresets>
</bsbPresets>
